package com.io.yutian.enderdragonwar.effect.types;

import com.io.yutian.enderdragonwar.EnderDragonWar;
import com.io.yutian.enderdragonwar.game.Game;
import com.io.yutian.enderdragonwar.effect.GameGiftEffect;
import com.io.yutian.pixelliveapi.api.effect.GiftEffectMetadata;
import org.bukkit.Particle;
import org.bukkit.attribute.Attribute;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;

import java.util.UUID;

public class AddMaxHealthEffect extends GameGiftEffect {

    public static UUID uuid = UUID.randomUUID();

    @Override
    public void apply(Game game, GiftEffectMetadata metadata) {
        Player player = game.getPlayer();
        game.addTask(new BukkitRunnable() {
            private int count = 0;

            @Override
            public void run() {
                if (count >= 50) {
                    cancel();
                    return;
                }
                player.spawnParticle(Particle.HEART, player.getLocation().add(0, 0.5, 0), 1, 0.25, 0.25, 0.25, 0.1);
                if (player.getAttribute(Attribute.GENERIC_MAX_HEALTH).getValue() < 120) {
                    player.getAttribute(Attribute.GENERIC_MAX_HEALTH).setBaseValue(player.getAttribute(Attribute.GENERIC_MAX_HEALTH).getBaseValue() + 2);
                    player.setHealth(Math.min(player.getHealth() + 2, player.getMaxHealth()));
                }
                count++;
            }
        }.runTaskTimer(EnderDragonWar.inst(), 0L, 1L));
    }

    @Override
    public int getQueueTime() {
        return 55;
    }

}
