package com.io.yutian.enderdragonwar.effect.types;

import com.io.yutian.enderdragonwar.EnderDragonWar;
import com.io.yutian.enderdragonwar.effect.GameGiftEffect;
import com.io.yutian.enderdragonwar.game.Game;
import com.io.yutian.pixelliveapi.api.PixelLiveAPI;
import com.io.yutian.pixelliveapi.api.data.RandomBox;
import com.io.yutian.pixelliveapi.api.data.RandomBoxEntry;
import com.io.yutian.pixelliveapi.api.effect.GiftEffectMetadata;
import com.io.yutian.pixelliveapi.api.util.RandomBoxHelper;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;

public class RandomBoxEffect extends GameGiftEffect {

    private static final String BOX_ID = "随机盲盒";

    @Override
    public void apply(Game game, GiftEffectMetadata metadata) {
        Player player = game.getPlayer();
        RandomBox randomBox = PixelLiveAPI.getRandomBoxManager().getRandomBox(BOX_ID);
        if (randomBox == null) {
            EnderDragonWar.inst().getLogger().warning("随机盲盒 "+BOX_ID+" 不存在");
        }
        RandomBoxHelper randomBoxHelper = randomBox.getRandomBoxHelper();
        BukkitTask task = new BukkitRunnable() {
            private int i = 0;
            @Override
            public void run() {
                RandomBoxEntry randomBoxEntry = randomBoxHelper.getRandomEffect();
                String effect = randomBoxEntry.getEffect().getEffect();
                int amount = randomBoxEntry.getEffect().getAmount();
                String showName = randomBoxEntry.getShowName() + (amount > 1 ? "X"+amount : "");
                if (i >= 12) {
                    player.sendTitle("§6随机盲盒", "§9整蛊效果: §e" + showName);
                    player.playSound(player.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 1);
                    PixelLiveAPI.getEffectQueueManager().addEffect(metadata.getAnchor(), metadata.getAudience(), effect, amount);

                    Bukkit.broadcastMessage("§c[消息]§a随机盲盒抽中了 §e" + showName);
                    cancel();
                    return;
                }
                player.sendTitle("§6随机盲盒", "§9整蛊效果: §e" + showName);
                player.playSound(player.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 1);
                i++;
            }
        }.runTaskTimer(EnderDragonWar.inst(), 0L, 5L);
        EnderDragonWar.getGame().addTask(task);
    }


    @Override
    public int getQueueTime() {
        return 12 * 5;
    }

}
